<dom-module id="dez-scroll">
  <template>
    
    <style>
      :host {
        display: flex;
        flex-direction: column;
      }

      #region {
        overflow: auto;
        flex-grow: 1;
      }
    </style>
    
    <div id="region">
      <slot></slot>
    </div>
    
  </template>
  
  <script>
    /**
     * `dez-scroll`
     * Scrolling container
     *
     * @customElement
     * @polymer
     * @demo demo/index.html
     */
    class DezScroll extends Polymer.Element {
      static get is() { return 'dez-scroll'; }

      static get properties() {
        return {
          // Only used for upward data flow
          // Cannot be set by parents, except through public functions used here
          scrollLeft: {
            type: Number,
            notify: true,
            value: 0,
            reflectToAttribute: true,
            observer: '_scrollLeftChanged'
          }
        }
      }

      ready () {
        super.ready();
        this.scrollTarget = this.$.region;
        // Update scrollLeft on user or animation scroll
        this.scrollTarget.addEventListener('scroll', e => this._scrollLeftChanged() );
      }

      // Ensures scrollLeft always contain the current scroll position
      // This avoids parent trying to change scroll-left instead of just using upward data flow
      _scrollLeftChanged() {
        this.scrollLeft = this.scrollTarget ? this.scrollTarget.scrollLeft : 0
      }

      // If loaded, start the scroll animation to a target
      scrollToTarget(left) {
        if (this.scrollTarget)
          this.scrollTarget.scroll({ left, behavior: 'smooth' });
      }

      // The width of the view
      get visibleWidth() {
        return window.innerWidth;
      }

      // A margin size in which scroll will avoid displaying information
      get margin() {
        return this.visibleWidth / 10;
      }

      // The view width minus the width of the right and left margins
      get usableWidth() {
        return this.visibleWidth - this.margin * 2;
      }

      // Returns truthy is the position is outside of view (excluding margins)
      // -1 if the position is to the left of the view
      // 0 if the position is visible
      // 1 if the position is to the right of the view
      _isPositionOutsideView(position) {
        const rightEdge = this.visibleWidth + this.scrollLeft;

        if (position < this.scrollLeft + this.margin) {
          return -1;
        } else if (position > rightEdge - this.margin) {
          return 1;
        } else {
          return 0;
        }
      }

      // If a position is not currently on screen, move it to the left of the screen
      // Used by the cursor
      scrollPositionInView(position) {
        const visibility = this._isPositionOutsideView(position);

        if (visibility != 0) {
          this.scrollToTarget(position - this.margin);
        }
      }

      // Maximize the visibility of a given range in view
      // Prioritize the start of the range
      scrollRangeInView(positionStart, positionEnd) {

        const startVisibility = this._isPositionOutsideView(positionStart);
        const endVisibility = this._isPositionOutsideView(positionEnd)

        // If range start is hidden to the left
        if (startVisibility < 0) {
          // Place range start at screen start
          this.scrollToTarget(positionStart - this.margin);
        // If range end is hidden to the right
        } else if (endVisibility > 0) {
          // Calculate range width
          const rangeWidth = positionEnd - positionStart;

          // If it's impossible to show range fully, show start
          if (rangeWidth > this.usableWidth) {
            this.scrollToTarget(positionStart - this.margin);
          // Otherwise, show the entire range
          } else {
            this.scrollToTarget(positionEnd - this.usableWidth - this.margin);
          }
        }
      }
    }

    window.customElements.define(DezScroll.is, DezScroll);
  </script>
</dom-module>
